//by Troy HYM

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <fstream.h>
#define MAX 200

FILE *fo;
FILE *fi;

char _perfil[MAX];
char _name[MAX];
char _uid[MAX];
char _gamistad[MAX];
char _edad[MAX];
char _foto[MAX];
int completo=0;

//###############################################################
void VolcadoConocidoToRDF(char *perfil, char *name, char *uid, char *gamistad, char *edad, char *foto)
{
  //inicio cabecera person
  fprintf(fo,"<knows>\n");
  fprintf(fo,"<Person>\n");
  //fin cabecera person
  fprintf(fo,"<perfil>");  fprintf(fo,perfil); fprintf(fo,"</perfil>\n");
  fprintf(fo,"<name>");  fprintf(fo,name); fprintf(fo,"</name>\n");
  fprintf(fo,"<rdfs:seeAlso rdf:resource=\"Profile.aspx?uid="); fprintf(fo,uid); fprintf(fo,"\"/>\n");
  fprintf(fo,"<gradoamistad>");  fprintf(fo,gamistad); fprintf(fo,"</gradoamistad>\n");
  fprintf(fo,"<Person>\n");
  fprintf(fo,"<edad>");  fprintf(fo,edad); fprintf(fo,"</edad>\n");
  fprintf(fo,"<foto>");  fprintf(fo,foto); fprintf(fo,"</foto>\n");
  fprintf(fo," </knows>\n");
    /*<knows>
     <Person>   
      <perfil>c4f29da62696f90a0a5463426fcd6273b47850bc</perfil>
      <name>Linus Torvalds</name>
      <rdfs:seeAlso rdf:resource="Profile.aspx?uid=11154901555501126999"/>   
      <gradoamistad>very good friend</gradoamistad>
     </Person>
     <edad>21</edad>
     <foto>69443.jpg</foto>
    </knows>*/
}
//###############################################################

int ComienzoContacto(char linea[1000])
{
  char delim[1000];
  linea[999]='\0';
  strcpy(delim,"href=\"Friends.aspx?gid=");
  if (strstr(linea,delim)) return 1;
  return 0;
}

//###############################################################

int main(int argc, char *argv[])
{
   if (argc != 2) return -1;
   fo = fopen("salida.rdf","w");
   ////fi = fopen(argv[1],"r");
   //fi = fopen("friends.html","r"); 
   ifstream ifs(argv[1],ios::in);

  //inicio volcado de cabecera rdf
  fprintf(fo,"<rdf:RDF\n");
  fprintf(fo,"xmlns=\"http://xmlns.com/foaf/0.1/\"\n" );
  fprintf(fo, "xmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n");
  fprintf(fo,"xmlns:contact=\"http://www.w3.org/2000/10/swap/pim/contact#\"\n");
  fprintf(fo,"xmlns:airport=\"http://www.daml.org/2001/10/html/airport-ont#\"\n");
  fprintf(fo,"xmlns:pos='http://www.w3.org/2003/01/geo/wgs84_pos#'\n");
  fprintf(fo,"xmlns:foaf=\"http://xmlns.com/foaf/0.1/\"\n");
  fprintf(fo,"xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n");
  fprintf(fo,"xmlns:rdfs=\"http://www.w3.org/2000/01/rdf-schema#\"\n");
  fprintf(fo,"xmlns:wordnet=\"http://xmlns.com/wordnet/1.6/\"\n");
  fprintf(fo,"xmlns:wot=\"http://xmlns.com/wot/0.1/\"\n");
  //fin volcado de cabecera rdf

  //inicio volcado cabecera Bill person
  fprintf(fo,">\n");
  fprintf(fo,"<foaf:maker>\n");
  fprintf(fo,"<Person>\n");
  fprintf(fo,"<name>Bill</name>\n");
  fprintf(fo,"<firstName>Gates</firstName>\n");
  //fin volcado cabecera Bill person

  char buffer[1000];
  buffer[0]='\0';
  int ini;
  while (!ifs.eof())
  {
    ifs.getline(buffer,999);
    //nos interesa identificar lineas de inicio o existencia de un contacto...
    if (ComienzoContacto(buffer) == 1)
    {
        //perfil
        strcpy(_perfil,"c4f29da62696f90a0a5463426fcd6273b47850bc");

        //uid
        while (strstr(buffer,"class=\"P\"") == NULL) ifs.getline(buffer,999);          
        //el uid esta en la cadena buffer
        int longi = strlen(buffer);
        for (int i=0; i<longi-5; i++)
        {
          if ((buffer[i]=='u') && (buffer[i+1]=='i')&&(buffer[i+2]=='d')&&(buffer[i+3]=='='))
          {
            char uidbuf[21];
            uidbuf[20]='\0';
            for (int j=0; j<20; j++)
            {
              if (buffer[i+j+4] != '\"')
                uidbuf[j] = buffer[i+j+4];
                ini = i+j+4;
            }
            strcpy(_uid,uidbuf);
            i=longi-5;
            //fprintf(fo,_uid);
            //fprintf(fo,"\n");
          }
        }

        //name
        //comenzamos en "ini"
        char namebuf[500];
        int inic=0, fina=0;
        int index=0;
        int seguir=1;
        while ((inic==0 && fina==1)||seguir==1)
        {
          if (buffer[ini] == '<') { fina=1; seguir=0; }
          if (buffer[ini] == '>') { inic=1; ini++; }
          
          if (inic==1 && fina==0)
          {
            namebuf[index]=buffer[ini] ;
            index++;
          }
          ini++;          
        }
        namebuf[index]='\0';
        strcpy(_name,namebuf);
        //fprintf(fo,_name);
        //fprintf(fo,"\n");

        //amistad
        //fprintf(fo,buffer);
        int unaamistad=0;
        char amibuf[100];
        while (unaamistad==0)
        {
          if (strstr(buffer,"friend") != NULL) { unaamistad=1; strcpy(amibuf,"friend");  }
          else if (strstr(buffer,"I know this person") != NULL) { unaamistad=1; strcpy(amibuf,"I know this person");  }
          else if (strstr(buffer,"good friend") != NULL) { unaamistad=1; strcpy(amibuf,"good friend");  }
          else if (strstr(buffer,"best friend") != NULL) { unaamistad=1; strcpy(amibuf,"best friend");  }
          else if (strstr(buffer,"acquaintance") != NULL) { unaamistad=1; strcpy(amibuf,"acquaintance");  }
          else if (strstr(buffer,"very good friend") != NULL) { unaamistad=1; strcpy(amibuf,"very good friend");  }
          else ifs.getline(buffer,999);
        }
        strcpy(_gamistad,amibuf);
        //fprintf(fo,_gamistad);
        //fprintf(fo,"\n");

        //
        VolcadoConocidoToRDF(_perfil, _name, _uid, _gamistad, "incompleto", "incompleto");
        //
     }
  }
  
  //fin
  fprintf(fo,"</Person>\n" );
  fprintf(fo,"</foaf:maker>\n" );
  fprintf(fo,"</rdf:Description>\n");
  fprintf(fo,"</rdf:RDF>\n");
  //fclose(fo);
  //fclose(fi);
  
  return EXIT_SUCCESS;
}
